#include    "ti83plus.inc"
;#define     bcall(xxxx)    .db $EF \ .dw xxxx
velocity    equ 48
score       equ OP6
#define     progStart   $9D95
.org        progStart-2
.db         $BB,$6D
     bcall(_RunIndicOff)
     bcall(_ChkFindSym)
     ld hl,highscore-9D91h
     add hl,de
     ld (score+2),hl
Main:
     call WaitForNoKey
     call DrawTopRow
     call BufferToLCD
     call VPutSI
     .db 32,8,"7=Play",0
     call VPutSI
     .db 32,40,"High:",0
     ld hl,2828h
     ld (penCol),hl
     ld hl,(highscore)
     call DispHL
     call VPutSI
     .db 32,72,"9=Exit",0
     ld hl,plotSScreen
     bcall(_SaveDisp)
     ei
MainLoop:
     halt
     ld a,(843Fh)
     cp 20
     jr nz,CheckReset
       ld bc,0908h
       call Animate
WaitForNoKey:
     halt
     ld a,(843Fh)
     or a
     jr nz,$-5
     ret
CheckReset:
     cp 28
     jr nz,CheckPlay
       ld bc,0508h
       call Animate
       call VPutSI
       .db 48,0,"Reset High Score?",0
       call VPutSI
       .db 56,0,"Enter=Yes",0
       halt
       ld a,(843Fh)
       or a
       jr z,$-5
       cp 9
       jp nz,Main
       ld hl,(OP6+2)
       xor a
       ld (hl),a
       inc hl
       ld (hl),a
       ld hl,Highscore
       ld (hl),a
       inc hl
       ld (hl),a
       jp Main
CheckPlay:
     cp 36
     jr nz,MainLoop
     ld bc,0108h
     call Animate
     call WaitForNoKey
     call Game
     jp Main
     
Game:
     ld a,64
     ld (smc_counter),a
     rlca
     ld (smc_difficulty),a
     xor a
     ld (ActiveHammer),a
     ld hl,molelut+23
     ld b,18
       ld (hl),a
       dec hl
       djnz $-2
     ld b,6
     dec a
     ld (hl),a
     dec hl
     djnz $-2
     call DrawTopRow
     xor a
     ld bc,128h
     call DrawSprite
     xor a
     ld bc,528h
     call DrawSprite
     xor a
     ld bc,928h
     call DrawSprite
     ld hl,0
     ld (score),hl
     ld a,r
     ld (randSeed),a
MLOOP:
     .db 6
smc_debounce:
     .db 0
     halt
     ld a,(843Fh)
     cp 15
     jp z,Lose
     ld (smc_debounce),a
     cp b
     jr nz,$+3
     xor a
     .db 06h     ;start of ld b,*
ActiveHammer:
     .db 0
     dec b
     jp p,HammerAnim
     ld hl,lose
     ld (smc_jump),hl
     cp 18
     jr nz,$+4
     ld b,1
     cp 26
     jr nz,$+4
     ld b,2
     cp 34
     jr nz,$+4
     ld b,3
     cp 20
     jr nz,$+4
     ld b,4
     cp 28
     jr nz,$+4
     ld b,5
     cp 36
     jr nz,$+4
     ld b,6
     dec b
     jp m,Moles
HammerAnim:
     ld a,b
     inc a
     ld (ActiveHammer),a
     ld hl,MoleLUT-1
     add a,l
     ld l,a
     jr nc,$+3
     inc h
     ld a,(hl)
     cp 27
     .db $D2     ;start of 'jp nc,**'
smc_jump:
     .dw lose
     ld (hl),255
     ld hl,jump2
     ld (smc_jump),hl
;     ld hl,(score)
;     inc hl
;     ld (score),hl
jump2:
     ld a,b
     add a,a
     add a,a
     ld hl,HammerLUT
     add a,l
     ld l,a
     jr nc,$+3
     inc h
     ld c,(hl)
     inc hl
     ld b,(hl)
     inc hl
     ld a,(hl)
     inc hl
     ld d,(hl)
     add a,d
     jr nz,$+7
       ld (hl),1
       ld (ActiveHammer),a
     cp 3
     jr nz,$+4
       ld (hl),255
     dec hl
     ld (hl),a
     call DrawSprite
Moles:
     ld hl,86ECh
     call ClearBuf
     .db 3Eh
smc_counter:
     .db 64
     dec a
     jr nz,molepreloop         
       call PRNGNibble
       ld c,a
       ld d,a
holesearch:
       ld hl,molelut-1
       ld b,6
       inc hl
       ld a,(hl)
       inc a
       jr nz,$+5
       dec c
       jr z,AddMole
       djnz holesearch+5
       ld a,c
       cp d
       jr z,newmole
       jr nz,holesearch
AddMole:
       ld (hl),0
       ld a,l
       add a,6
       ld l,a
       jr nc,$+3
       inc h
       ld (hl),16
newmole:
       ld hl,(score)
       inc hl
       ld (score),hl
       ld a,l
       and 15
       .db 3Eh
smc_difficulty:
       .db 128
       jr nz,molepreloop
       cp 17
       jr c,molepreloop
       sub 16
       ld (smc_difficulty),a
molepreloop:
     ld (smc_counter),a
     ld b,6
     ld ix,molelut      ;ix+6 = counters. ix+12 = velocity, ix+18=overflow
moleloop:
     ld a,(ix)
     or a
     jp m,MoleComputed
     jr nz,AdjustVelocity
       dec (ix+6)
       jr nz,DrawMole
       ld (ix+12),velocity+1
AdjustVelocity:
     dec (ix+12)
     ld a,(ix+12)
     jp p,Rising
;falling
     add a,(ix+18)
     ld (ix+18),a
     add a,velocity
     jr nc,DrawMole
     dec (ix)
     jr nz,DrawMole-3
     jp lose
Rising:
     add a,(ix+18)
     ld (ix+18),a
     sub velocity
     jr c,DrawMole
     inc (ix)
     ld (ix+18),a
DrawMole:
     push bc
     ld d,7
     ld a,(ix)
     add a,3
     cp d
     jr nc,$+3
     ld d,a
     sub (ix+24)
     cpl
     add a,3
;     sub d
     ld c,a
;C is the Y coordinate
;(ix+30) is te base X coordinate
;D is the height of the sprite
     ld b,0
     ld h,b
     ld l,c
     add hl,hl
     add hl,bc
     add hl,hl
     add hl,hl
     ld a,(ix+30)
     add a,$EC      ;LSB of saveSScreen
     ld c,a
     ld b,86h       ;MSB of saveSScreen
     add hl,bc
     ld a,d
     or a
     jr z,MoleComputed-1
     ld de,MoleSprite
     ld bc,10
     ex de,hl
MoleSpriteLoop:
     inc c
     inc c
     ldi
     ldi
     ex de,hl
     add hl,bc
     ex de,hl
     dec a
     jr nz,MoleSpriteLoop
     pop bc
MoleComputed:
     inc ix
     djnz moleloop
     call BufferToLCD
     jp MLoop
Animate:
     push bc
     ld a,1
     call DrawSpriteLCD
     pop bc
     push bc
     ld a,2
     call DrawSpriteLCD
     pop bc
     push bc
     ld a,3
     call DrawSpriteLCD
     pop bc
     push bc
     ld a,2
     call DrawSpriteLCD
     pop bc
     push bc
     ld a,1
     call DrawSpriteLCD
     pop bc
     xor a
DrawSpriteLCD:
     call DrawSprite
     ld hl,plotSScreen
     jr $+5
#define     LCDDelay()    in a,(10h) \ rlca \ jr c,$-3
;===============================================================
BufferToLCD:
;===============================================================
     ld hl,saveSScreen
     ld ix,plotSScreen
setrow:
     LCDDelay()
     ld a,$80
     out (16),a
     ld de,12
     LCDDelay()
     ld a,20h
col:
     ld (Var2),a
     out (10h),a
     ld bc,4011h
row:
     ld a,(hl)
     or (ix)
     ld (hl),a
     LCDDelay()
     outi
     dec hl
     add hl,de          ;11
     add ix,de          ;15
     jr nz,row
;     LCDDelay()
     .db 3Eh             ;ld a,*
Var2:
     .db 20h
     inc a
     dec h
     dec h
     dec h
     inc hl
     .db $DD \ dec h
     .db $DD \ dec h
     .db $DD \ dec h
     inc ix
     cp $2c
     jp nz,col
     ret
DrawTopRow:
     ld hl,saveSScreen
     call ClearBuf
     ld hl,plotSScreen
     call ClearBuf
     xor a
     ld bc,108h
     call DrawSprite
     xor a
     ld bc,508h
     call DrawSprite
     xor a
     ld bc,908h
DrawSprite:
     add a,a
     ld hl,SpriteLUT
     add a,l
     ld l,a
     jr nc,$+3
     inc h
     ld e,(hl)
     inc hl
     ld d,(hl)
     ld a,(de)
     add a,c
     ld c,a
     ld a,b
     ld b,0
     ld h,b
     ld l,c
     add hl,hl
     add hl,bc
     add hl,hl
     add hl,hl
     ld b,93h      ;MSB of plotSScreen
     add a,40h     ;LSB of plotSScreen
     ld c,a
     add hl,bc
     ld bc,10
     ld a,24
     ex de,hl
     sub (hl)
     inc hl
SpriteLoop:
     inc c
     inc c
     ldi
     ldi
     ex de,hl
     add hl,bc
     ex de,hl
     dec a
     jr nz,SpriteLoop
     ret
ClearBuf:
     ld (hl),0
     ld d,h
     ld e,l
     inc de
     ld bc,767
     ldir
     ret
;======================================
;yummy pseudo-random number generators
;======================================
PseudoRandByte:
     .db 3Eh
randSeed:
     .db 0
     ld h,a
     add a,a
     add a,h
     add a,a
     add a,a
     add a,h
     add a,83
     ld (randSeed),a
     ret
PRNGNibble:
;Returns A as a PRN from 0 to 15
     call PseudoRandByte
;this is a piece of a square root algoithm
     ld bc,0800h   ;3  10      ;10
     ld e,c        ;1  4       ;4
     ld l,c
     xor a         ;1  4       ;4
SHL4Loop:          ;           ;
     add hl,hl     ;1  11      ;88
     rl c          ;2  8       ;64
     adc hl,hl     ;2  15      ;120
     rl c          ;2  8       ;64
     jr nc,$+4     ;2  7|12    ;96+3y   ;y is the number of overflows. max is 2
     set 0,l       ;2  8       ;--
     ld a,e        ;1  4       ;32
     add a,a       ;1  4       ;32
     ld e,a        ;1  4       ;32
     add a,a       ;1  4       ;32
     bit 0,l       ;2  8       ;64
     jr nz,$+5     ;2  7|12    ;144-6y
     sub c         ;1  4       ;32
     jr nc,$+7     ;2  7|12    ;96+15x  ;number of bits in the result
         ld a,c    ;1  4       ;
         sub e     ;1  4       ;
         inc e     ;1  4       ;
         sub e     ;1  4       ;
         ld c,a    ;1  4       ;
     djnz SHL4Loop ;2  13|8    ;99
     ld a,e
     and 15
     ret
DispHL:
;Inputs:
;     HL is the 16-bit number
;     DE points to the end of where to convert the number to
     ld de,OP1+6
     xor a
     ld (de),a
     set fracDrawLFont,(IY+fontFlags)
FormHLLoop:
     ld bc,100Ah
     xor a
       add hl,hl
       rla
       cp c
       jr c,$+4
         inc l
         sub c
       djnz $-7
     add a,30h
     dec e
     ld (de),a
     ld a,h
     or l
     jr nz,FormHLLoop
     ex de,hl
     bcall(_VPutS)
     res fracDrawLFont,(IY+fontFlags)
     ret
VPutSI:
     pop hl
     ld d,(hl)
     inc hl
     ld e,(hl)
     inc hl
     ld (penCol),de
     bcall(_VPutS)
     jp (hl)
lose:
     .db 11h   ;start of ld de,**
highscore:
     .dw 0
     ld hl,(score)
     or a
     sbc hl,de
     ret c
     add hl,de
     ld (highscore),hl
     ex de,hl
     ld hl,(OP6+2)
     ld (hl),e
     inc hl
     ld (hl),d
     ret
HammerLUT:
     .db 28h,9,0,1
     .db 28h,5,0,1
     .db 28h,1,0,1
     .db 08h,9,0,1
     .db 08h,5,0,1
     .db 08h,1,0,1
molelut:
     .db 255,255,255,255,255,255
;counters for when to pop out
     .db 0,0,0,0,0,0
;velocity
     .db 0,0,0,0,0,0
;overflow
     .db 0,0,0,0,0,0
;base y
     .db 62,62,62,30,30,30
;base x
     .db 9,5,1,9,5,1


SpriteLUT:
     .dw sprite0,sprite1,sprite2,sprite3
sprite0:
     .db 0
     .db $03,$80,$07,$C0,$04,$40,$07,$C0,$03,$80,$01,$00,$01,$00,$01,$00
     .db $03,$80,$03,$80,$04,$40,$04,$40,$07,$C0,$08,$20,$0A,$A0,$07,$C0
     .db $01,$00,$01,$00,$02,$80,$0F,$E0,$70,$1C,$80,$02,$70,$1C,$0F,$E0
sprite1:
     .db 0
     .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$03,$80,$07,$C0,$04,$40
     .db $04,$40,$07,$C0,$03,$80,$01,$00,$07,$C0,$0C,$60,$0A,$A0,$07,$C0
     .db $01,$00,$01,$00,$02,$80,$0F,$E0,$70,$1C,$80,$02,$70,$1C,$0F,$E0
sprite2:
     .db 5,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
     .db $03,$80,$07,$C0,$0C,$60,$0C,$60,$04,$40,$07,$C0
     .db $03,$80,$01,$00,$02,$80,$0F,$E0,$70,$1C,$80,$02,$70,$1C,$0F,$E0
sprite3:
     .db 10
     .db $00,$00,$00,$00,$00,$00,$07,$C0,$08,$20,$0B,$A0
     .db $07,$C0,$04,$40,$04,$40,$0C,$60,$77,$DC,$83,$82,$70,$1C,$0F,$E0
MoleSprite:
     .db $0E,$E0
     .db $0D,$60
     .db $04,$40
     .db $0A,$A0
     .db $0C,$60
     .db $0F,$E0
     .db $06,$C0
